Attribute VB_Name = "exportsGeneric"
Option Explicit
'
' buffer da utilizzare con le funzioni esportate (dove richiesto):
' In alternativa, servirsi della dichiarazione di Stringhe fisse.
Type smallest_string
   buff As String * 32
End Type

Type small_string
   buff As String * 64
End Type

Type medium_string
   buff As String * 128
End Type

Type large_string
   buff As String * 256
End Type

Type largest_string
   buff As String * 512
End Type


'Funzione:       generic_set_remote_host
'      -----------------------------------------------------------------------------
'      Descrizione: setta il server remoto a cui connettersi per la richiesta.
'      Parametri:   un parametro di tipo stringa di dimensione 32 bytes (smallest)
'                remoteIP: server remoto (pu essere sia nome dominio che IP senza
'                     specificare il protocollo - es: www.miosito.it)
'      Restituisce: valore boolean
'                true: settaggio avvenuto
'                     false: altrimenti
'        Nota:      usando la famiglia di funzioni vodafone_XXXX_XXXX, le impostazioni
'                vengono perse.
'      ------------------------------------------------------------------------------
Public Declare Function generic_set_remote_host Lib "engineSMS.dll" (ByVal remoteIP As String) As Boolean



'Funzione:       generic_set_remote_host
'      -----------------------------------------------------------------------------
'      Descrizione: setta il server remoto a cui connettersi per la richiesta.
'      Parametri:   un parametro di tipo unsigned long
'                remotePort: porta da utilizzare per la connessione
'      Restituisce: valore boolean
'                true: settaggio avvenuto
'                     false: altrimenti
'        Nota:      usando la famiglia di funzioni vodafone_XXXX_XXXX, le impostazioni
'                vengono perse.
'      ------------------------------------------------------------------------------
Public Declare Function generic_set_remote_port Lib "engineSMS.dll" (ByVal remoteIP As Long) As Boolean




'Funzione:       generic_send_request
'      -----------------------------------------------------------------------------
'      Descrizione: permette di inviare richieste generiche, ma garantito solo
'                protocollo HTTP.
'      Parametri:   due parametri di tipo stringa (puntatori a char)
'                   uno tipo boolean
'                uri: richiesta con relativi parametri
'                     (es: '/mio/path/prova.asp?user=a&passwd=b')
'                     path: percorso in cui memorizzare la risposta del server senza
'                           header. Se impostato a NULL, non salva la risposta
'                     isVodafone: specifica se le richieste da inoltrare sono verso Vodafone
'      Restituisce: valore tipo boolean
'                     true se la richiesta  stata mandata e/o salvata
'                     false altrimenti
'      ------------------------------------------------------------------------------
Public Declare Function generic_send_request Lib "engineSMS.dll" (ByVal uri As String, ByVal path As String, ByVal isVodafone As Boolean, ByVal GETMethod As Boolean) As Boolean



'Funzione:       generic_send_request_mem
'      -----------------------------------------------------------------------------
'      Descrizione: permette di inviare richieste generiche, ma garantito solo
'                protocollo HTTP. Per la descrizione guardare la
'                generic_send_request().
'                L 'unica differenza  data dalla possibilit di salvare il
'                contenuto della richiesta direttamente in un'area di memoria
'                rappresentata da retBuffer. Quest ultimo non pu essere
'                un valore NULL.
'      Restituisce: valore tipo boolean
'                     true se la richiesta  stata mandata e/o salvata
'                     false altrimenti
'        NOTA:         cura del programmatore riservare una quantit di memoria
'                     sufficientemente grande da contenere i dati restituiti.
'        NOTA per VB: il limite massimo consentito in Visual Basic  pari a
'                     65525 bytes.
'      ------------------------------------------------------------------------------
Public Declare Function generic_send_request_mem Lib "engineSMS.dll" (ByVal uri As String, ByVal retBuffer As String, ByVal isVodafone As Boolean, ByVal isGETMethod As Boolean) As Boolean



'Funzione:       generic_get_server_name
'      -----------------------------------------------------------------------------
'      Descrizione: restituisce la signature del server web che ha risposto
'      Parametri:   un parametro di tipo stringa (puntatore a char)
'      Restituisce: valore lungo senza segno
'                restituisce il numero di caratteri che sono stati letti
'                     altrimenti zero
'        Nota:      oltre a restituire zero in caso di non successo, imposta
'                     anche il buffer retServerName a vuoto.
'      ------------------------------------------------------------------------------
Public Declare Function generic_get_server_name Lib "engineSMS.dll" (ByVal retServerName As String) As Long

   

'Funzione:       generic_get_cookie
'      -----------------------------------------------------------------------------
'      Descrizione: restituisce i cookie settati dalla risposta del server.
'      Parametri:   un parametro di tipo stringa (puntatore a char) di largest_string
'                   retCookie: conterr i cookie settati
'                   un parametro di tipo boolean
'                   isVodafone: se la richiesta  specifica per vodafone
'      Restituisce: valore lungo senza segno
'                restituisce il numero di caratteri che sono stati letti
'                     altrimenti zero
'        Nota:      oltre a restituire zero in caso di non successo, imposta
'                     anche il buffer retCookie a vuoto.
'        ATTENZIONE:  la funzione potrebbe causare un buffer overflow in caso di
'                     eccedenza di informazioni.
'      ------------------------------------------------------------------------------
Public Declare Function generic_get_cookie Lib "engineSMS.dll" (ByVal retCookie As String, ByVal isVodafone As Boolean) As Long
   
   

'Funzione:       generic_reset_cookie
'      -----------------------------------------------------------------------------
'      Descrizione: quando vengono effettuate delle richieste generiche, i cookie
'                     vengono memorizzati ed accumulati in memoria. Talvolta si
'                     desidera effettuare delle richieste ex-novo (es: verso altri
'                     host) per cui  necessario pulire i cookie precedentemente
'                     usati.
'                     La funzione permette di effettuare questa operazione.
'Parametri:         nessuno
'Restituisce:       nessuno
'      NOTA:        da chiamare prima di inviare una nuova richiesta
'                   tramite la funzione generic_send_request().
'      ------------------------------------------------------------------------------
Public Declare Sub generic_reset_cookie Lib "engineSMS.dll" ()

