Attribute VB_Name = "basExportSMS"
Option Explicit
'
' buffer da utilizzare con le funzioni esportate (dove richiesto):
' In alternativa, servirsi della dichiarazione di Stringhe fisse.
Type smallest_string
   buff As String * 32
End Type

Type medium_string
   buff As String * 128
End Type
'
' struttura con i dati per gli invii:
Type smsuser_t
   phone As String   ' telefono a cui inviare il messaggio
   sms As String    ' sms da inviare
   forClass As Long ' al ritorno conterr 0 se l'invio non  andato a buon fine
End Type
'
'
'Funzione:       vodafone_init_account
'      -----------------------------------------------------------------------------
'      Descrizione: permette di autenticarsi presso il sito vodafone per usufruire
'                dei servizi riservati.
'      Parametri:   due parametri di tipo stringa (puntatori a char)
'                username: nome login da utilizzare per l'accesso
'                password: parola segreta da utilizzare per l'accesso
'      Restituisce: valore boolean
'                true: se il riconoscimento dell'utente avviene con successo
'                false: in caso contrario
'      ------------------------------------------------------------------------------
Public Declare Function vodafone_init_account Lib "engineSMS.dll" (ByVal username As String, ByVal password As String) As Boolean
Public Declare Function vodafone_init_account_with_sim Lib "engineSMS.dll" (ByVal getInfoSim As Boolean, ByVal username As String, ByVal password As String) As Boolean


'Funzione:       vodafone_destroy_account
'      -----------------------------------------------------------------------------
'      Descrizione: permette di effettuare il logout presso il sito vodafone.
'Parametri:         nessun parametro
'      Restituisce: valore boolean
'                true: se il logout per l'utente avviene con successo
'                false: in caso contrario
'      NOTA:     Il parametro di ritorno non garantisce che il logout avvenga
'                con certezza.
'      ------------------------------------------------------------------------------
Public Declare Function vodafone_destroy_account Lib "engineSMS.dll" () As Boolean



' Funzione:         vodafone_send_multiple_sms
'        -----------------------------------------------------------------------------
'        Descrizione: inizializza username e password che verranno utilizzate dalla
'              funzione vodafone_send_multiple_sms.
'        Parametri: due parametri di tipo string (puntatori a char)
'        username: puntatore a stringa che conterr il nome utente da usare per vodafone.
'        password: puntatore a stringa che conterr la password da usare per vodafone.
'
'        ATTENZIONE: la funzione  da usare ESCLUSIVAMENTE per gli invii in multi-threading
'             e non  necessaria una chiamata a vodafone_init_account.
'        ------------------------------------------------------------------------------
Public Declare Sub vodafone_init_multiple_account Lib "engineSMS.dll" (ByVal username As String, ByVal password As String)
        
        

'Funzione:         vodafone_send_multiple_sms
'        -----------------------------------------------------------------------------
'        Descrizione: permette di usufruire del servizio di invio SMS verso cellulari
'        omnitel in modalit multi-threading.
'        Parametri: un parametri di tipo generico (puntatori a void)
'            array: puntatore a struttura smsuser_t (descritta ad inizio pagina)
'        Restituisce: valore boolean - e valori in array
'            true: se la funzione ha avviato i processi in modo corretto.
'            false: in caso contrario
'            nella struttura array, viene impostato il puntatore generico
'               forClass per ogni record utente, con valore true se il
'                 messaggio  stato consegnato, false altrimenti.
'        ATTENZIONE: prima di chiamare questa funzione, si deve usare la
'               vodafone_init_multiple_account.
'               Non  necessaria una precedente chiamata a vodafone_init_account.
'               Sebbene sia possibile specificare num_thread, si consiglia di
'               usare come valore num_thread = 2. Infatti valori superiori, hanno
'               riportato un peggioramento delle prestazioni e la mancata consegna
'               di alcuni messaggi. La funzione potrebbe bloccarsi.
'        ------------------------------------------------------------------------------
Public Declare Function vodafone_send_multiple_sms Lib "engineSMS.dll" (ByRef arrayDati As smsuser_t, ByVal num_thread As Long) As Boolean
Public Declare Function vodafone_send_multiple_sms_with_sim Lib "engineSMS.dll" (ByRef arrayDati As smsuser_t, ByVal num_thread As Long, ByRef sim As String) As Boolean
Public Declare Function vodafone_send_multiple_sms_with_sim_VB Lib "engineSMS.dll" _
      (ByRef arrayDati As smsuser_t, ByVal num_thread As Long, ByVal num_elem As Long, ByRef sim As String) As Boolean



'Funzione:       vodafone_send_sms
'      -----------------------------------------------------------------------------
'      Descrizione: permette di usufruire del servizio di invio SMS verso cellulari
'                omnitel, previa autenticazione. Vedere vodafone_init_account.
'      Parametri:   due parametri di tipo stringa (puntatori a char)
'                phone: numero di telefono destinatario
'                message: messaggio da inviare al numero di destinazione.
'                       Lunghezza massima 360 caratteri (no demo version).
'      Restituisce: valore boolean
'                true: se la consegna del messaggio al provider  avvenuta.
'                false: in caso contrario
'      Note:     La consegna del messaggio non garantisce che questo venga
'                inviato subito al destinatario.
'      ------------------------------------------------------------------------------
Public Declare Function vodafone_send_sms Lib "engineSMS.dll" (ByVal phone As String, ByVal Message As String) As Boolean


   
'Funzione:       vodafone_get_max_sms_length
'      -----------------------------------------------------------------------------
'      Descrizione: restituisce il numero massimo di caratteri che  possibile
'                utilizzare All 'interno di un sms.
'Parametri:         nessuno
'Restituisce:       valore intero
'                numero di caratteri che  possibile utilizzare.
'      ------------------------------------------------------------------------------
Public Declare Function vodafone_get_max_sms_length Lib "engineSMS.dll" () As Long




'Funzione:       vodafone_get_tot_sms_sent
'      -----------------------------------------------------------------------------
'      Descrizione: restituisce il numero totale di sms inviati con successo.
'      Parametri:         nessuno
'      Restituisce:       valore intero
'                 numero di messaggi che sono stati inviati con successo durante
'                la sessione aperta.
'      Nota:        Per durata della sessione si intende dalla creazione di una istanza
'                della dll fino alla sua distruzione.
'      ATTENZIONE:  il valore restituito  volatile; per cui, prima della
'                distruzione dell 'oggetto, assicurarsi di memorizzarlo
'                se si intende usarlo successivamente.
'      ------------------------------------------------------------------------------
Public Declare Function vodafone_get_tot_sms_sent Lib "engineSMS.dll" () As Long


'Funzione:       vodafone_get_tot_sms_error
'      -----------------------------------------------------------------------------
'      Descrizione: restituisce il numero totale di sms per cui  avvenuto un
'                tentativo di invio non andato a buon fine.
'      Parametri:         nessuno
'      Restituisce:       valore intero
'                 numero di messaggi che non sono stati inviati con successo durante
'                la sessione aperta.
'      Nota:        Per durata della sessione si intende dalla creazione di una istanza
'                della dll fino alla sua distruzione. La funzione tiene traccia di
'                tutti gli invii non andati a buon fine, sia per un dato sms che per
'                gli altri. Valore cumulativo.
'      ATTENZIONE:  il valore restituito  volatile; per cui, prima della
'                distruzione dell 'oggetto, assicurarsi di memorizzarlo
'                se si intende usarlo successivamente.
'      ------------------------------------------------------------------------------
Public Declare Function vodafone_get_tot_sms_error Lib "engineSMS.dll" () As Long


'Funzione:       vodafone_get_login
'      -----------------------------------------------------------------------------
'      Descrizione: permette di usufruire del servizio di identificazione del
'                cliente appena autenticatosi. Vedere vodafone_init_account.
'      Parametri:   un parametro di tipo stringa (puntatori a char)
'                ret_smallest_login: buffer di dimensione 32 bytes in cui
'                verr riposto il nome utente di benvenuto.
'      Restituisce:       il numero di caratteri effettivamente copiati
'      Note:      cura del programmatore allocare la memoria necessaria per
'                contenere i dati restituiti. In caso di chiamata senza precedente
'                autenticazione, il buffer di memoria sar posto a zero.
'      ------------------------------------------------------------------------------
Public Declare Function vodafone_get_login Lib "engineSMS.dll" (ByVal ret_smallest_login As String) As Long



'Funzione:       vodafone_get_total_sims
'      -----------------------------------------------------------------------------
'      Descrizione: ottiene il numero complessivo di sim registrate nell'account.
'      Parametri:   nessuno
'      Restituisce: nuemero di sim per l'account
'      ------------------------------------------------------------------------------
Public Declare Function vodafone_get_total_sims Lib "engineSMS.dll" () As Long
    


'Funzione:       vodafone_is_used_sim
'      -----------------------------------------------------------------------------
'      Descrizione: controlla se la sim identificata da indexSim  quella
'                     correntemente utilizzata.
'      Parametri:   indexSim: indice della sim per cui si vuole avere conferma
'      Restituisce: true se la sim  quella utilizzata al momento, false altrimenti.
'      ------------------------------------------------------------------------------
Public Declare Function vodafone_is_used_sim Lib "engineSMS.dll" (ByVal indexSim As Long) As Boolean
    
    

'Funzione:       vodafone_get_current_used_sim
'      -----------------------------------------------------------------------------
'      Descrizione: restituisce il numero di cellulare attualmente utilizzato
'                     per inviare gli sms.
'      Parametri:   un parametro di tipo stringa (puntatori a char)
'                ret_smallest_phone: buffer di dimensione 32 bytes in cui
'                verr riposto il numero di telefono.
'      Restituisce: nuemero di caratteri effettivamente copiati
'      Note:      cura del programmatore allocare la memoria necessaria per
'                contenere i dati restituiti. In caso di chiamata senza precedente
'                autenticazione, il buffer di memoria sar posto a zero.
'      ------------------------------------------------------------------------------
Public Declare Function vodafone_get_current_used_sim Lib "engineSMS.dll" (ByVal ret_smallest_phone As String) As Long
    
   

'      Funzione: vodafone_set_other_sim - 2 versioni
'      -----------------------------------------------------------------------------
'      Descrizione: permette di settare la sim da utilizzare per l'invio degli sms.
'                   Per coloro che hanno pi sim registrate in un unico account
'                   sul sito vodafone.
'      Parametri:   un parametro di tipo stringa (puntatori a char)
'                smallest_phone: buffer di dimensione 32 bytes in cui
'                 contenuto il numero che si intende usare.
'                O indice della sim che si intende impostare come attiva.
'      Restituisce: true se il settaggio  avvenuto, false altrimenti.
'      ------------------------------------------------------------------------------
Public Declare Function vodafone_set_other_sim Lib "engineSMS.dll" (ByVal smallest_phone As String) As Boolean
Public Declare Function vodafone_set_other_sim_by_index Lib "engineSMS.dll" (ByVal indexSim As Long) As Boolean



'Funzione:       vodafone_get_sim
'      -----------------------------------------------------------------------------
'      Descrizione: reperisce una sim nell'insieme relativoe all'account.
'      Parametri:   un parametro di tipo stringa (puntatori a char)
'                ret_smallest_phone: buffer di dimensione 32 bytes in cui
'                verr inserito il numero.
'                indexSim: indice che identifica la sim che si vuole ottenere.
'      Restituisce: numero di caratteri del numero reperito. Altrimenti zero.
'      ------------------------------------------------------------------------------
Public Declare Function vodafone_get_sim Lib "engineSMS.dll" (ByVal ret_smallest_phone As String, ByVal indexSim As Long) As Long


'Funzione:       vodafone_get_credit
'      -----------------------------------------------------------------------------
'      Descrizione: restituisce informazioni sulla libreria e sul creatore della
'                stessa.
'      Parametri:   un parametro di tipo stringa (puntatori a char)
'                ret_medium_version: buffer di dimensione 128 bytes in cui
'                verr riposto il credito.
'      Restituisce:       il numero di caratteri effettivamente copiati
'      Note:      cura del programmatore allocare la memoria necessaria per
'                contenere i dati restituiti. In caso di errore, il buffer di
'                memoria sar posto a zero.
'      ------------------------------------------------------------------------------
Public Declare Function vodafone_get_credit Lib "engineSMS.dll" (ByVal ret_medium_version As String) As Long
