Attribute VB_Name = "exportsVirgilio"
Option Explicit


'Funzione:       virgilio_init_account
'      -----------------------------------------------------------------------------
'      Descrizione: permette di autenticarsi presso il sito virgilio per usufruire
'                dei servizi riservati.
'      Parametri:   tre parametri di tipo stringa (puntatori a char)
'                username: nome login da utilizzare per l'accesso senza dominio.
'                password: parola segreta da utilizzare per l'accesso
'                dominio: identifica il dominio su cui operare:
'                              "virgilio.it"  per servizi Virgilio (testato)
'                              "tin.it"       per servizi Tin (non testato)
'                              "alice.it"     per servizi Alice (non considerato)
'      Restituisce: valore boolean
'                true: se il riconoscimento dell'utente avviene con successo
'                false: in caso contrario
'      ------------------------------------------------------------------------------
Public Declare Function virgilio_init_account Lib "engineSMS.dll" (ByVal username As String, ByVal password As String, ByVal dominio As String) As Boolean



'Funzione:       virgilio_destroy_account
'      -----------------------------------------------------------------------------
'      Descrizione: permette di effettuare il logout presso il sito virgilio.
'Parametri:         nessun parametro
'      Restituisce: valore boolean
'                true: se il logout per l'utente avviene con successo
'                false: in caso contrario
'      NOTA:     Il parametro di ritorno non garantisce che il logout avvenga
'                con certezza.
'      ------------------------------------------------------------------------------
Public Declare Function virgilio_destroy_account Lib "engineSMS.dll" () As Boolean




'Funzione:       virgilio_control_new_mail
'      -----------------------------------------------------------------------------
'      Descrizione: previa autenticazione, restituisce il numero di nuovi
'                   messaggi e-mail presenti per l'account.
'Parametri:         nessuno
'Restituisce:       valore numerico
'                = 0: se non ci sono nuove mail
'                > 0: in caso sono presenti nuove mail
'                -1 : in caso di mancata autenticazione o errore
'      ------------------------------------------------------------------------------
Public Declare Function virgilio_control_new_mail Lib "engineSMS.dll" () As Long



'Funzione:       virgilio_get_all_prefix_number
'      -----------------------------------------------------------------------------
'      Descrizione: previa autenticazione, reperisce tutti i prefissi, nazionali
'                     ed internazionali, a cui  possibile inviare sms.
'      Parametri:   variabile di tipo char
'                     delimiter: indica il carattere che separer ogni elemento
'                                dell 'array, secondo il seguente formato
'                                (es con delimiter= '$'):
'                                prefisso|titolo$prefisso|titolo$...
'                                La pipe (|) separa di default il prefisso ed il titolo.
'                     variabile di tipo puntatore:
'                               conterr i dati dei prefissi
'      Restituisce: restituisce il numero di carattere inseriti nel buffer.
'                   restituisce zero se non viene scritto nulla nel buffer.
'      NOTA:         cura del programmatore allocare una quantit abbastanza
'                     grande da contenere i dati.
'      ------------------------------------------------------------------------------
Public Declare Function virgilio_get_all_prefix_number Lib "engineSMS.dll" (ByVal retBuffer As String, ByVal delimiter As Byte) As Long
    


'Funzione:       virgilio_send_sms
'      -----------------------------------------------------------------------------
'      Descrizione: previa autenticazione, permette di inviare sms.
'      Parametri:   due puntatori a carattere
'                   phone: rappresenta il numero telefonico a cui inviare l'sms;
'                          deve contenere anche il prefisso internazionale (es: +39)
'                     message: messaggio che deve essere inviato.
'Restituisce:       valore booleano
'                true: invio eseguito correttamente
'                false: altrimenti
'      ------------------------------------------------------------------------------
Public Declare Function virgilio_send_sms Lib "engineSMS.dll" (ByVal phone As String, ByVal message As String) As Boolean



'Funzione:       virgilio_get_max_char_sms
'      -----------------------------------------------------------------------------
'      Descrizione: previa autenticazione, permette di reperire il numero
'                   massimo di caratteri che costituiscono un sms.
'Parametri:           nessuno
'Restituisce:       valore numerico
'                > 0: caratteri disponibili per un sms
'                = 0: errore (autorizzazione non avvenuta o problemi di conn.)
'      ------------------------------------------------------------------------------
Public Declare Function virgilio_get_max_char_sms Lib "engineSMS.dll" () As Long



'Funzione:       virgilio_get_info_sms
'      -----------------------------------------------------------------------------
'      Descrizione: previa autenticazione, permette di ottenere informazioni
'                   sullo stato degli sms.
'      Parametri:   due puntatori a short
'                   max_sms: verr memorizzato il numero di sms consentito
'                            giornalmente.
'                     cur_sent: verr memorizzato il numero di sms inviati.
'Restituisce:       valore booleano
'                true: informazioni reperite correttamente
'                false: altrimenti ed imposta le variabili al valore 0.
'      ------------------------------------------------------------------------------
Public Declare Function virgilio_get_info_sms Lib "engineSMS.dll" (ByRef max_sms As Long, ByRef cur_sent As Long) As Boolean
